searchNodes=[{"doc":"An unofficial Gumroad API client for Elixir applications. ⚠️ Pay heed! This package does not yet implement the complete Gumroad API. See the &quot;Incomplete implementation&quot; section below for more details. Documentation Full documentation available on HexDocs . Usage iex&gt; { :ok , products } = Gumroad . get_products ( ) iex&gt; products [ % Gumroad.Product { id : &quot;...&quot; , name : &quot;...&quot; } , % Gumroad.Product { id : &quot;...&quot; , name : &quot;...&quot; } ] iex&gt; { :ok , subscribers } = Gumroad . get_subscribers ( List . first ( products ) . id ) iex&gt; subscribers [ % Gumroad.Subscriber { id : &quot;...&quot; , status : &quot;alive&quot; } ] Installation Add gumroad_elixir to your list of dependencies in mix.exs : def deps do [ { :gumroad_elixir , &quot;~&gt; 0.1.0&quot; } ] end Then, configure your Gumroad access token : # config.exs config :gumroad_elixir , :access_token , &quot;your-gumroad-access-token&quot; Configuration Configuration properties on the :gumroad_elixir application are: :access_token (required) - The access token used to authenticate to the Gumroad API. (For details on how to create an access token, see Gumroad docs ). :client (defaults to Gumroad.Client.Live ) - The client implementation to use when handling API operations. Used for swithcing between a mock client and one that makes requests against the live Gumroad API. More details on the Gumroad.Client docs . Error handling Error messages sent by Gumroad's API in response to failed requests are propagated as-is to your application, with the from_gumroad property set to true : iex&gt; Gumroad . get_sale ( &quot;not-a-real-sale&quot; ) { :error , % Gumroad.Error { from_gumroad : true , reason : &quot;The sale was not found.&quot; } } Errors caused by other reasons (like network timeouts) have the from_gumroad property set to false : # Disconnect wi-fi, and... iex&gt; Gumroad.Client . get_sale ( &quot;not-a-real-sale&quot; ) { :error , % Gumroad.Error { from_gumroad : false , reason : :timeout } } Authentication An access token is included as a parameter on each request made to the Gumroad API. To create an access token, see Gumroad's docs . Testing Gumroad doesn't currently offer a native solution for local development or testing. To make up for this, this package includes local dev and testing mocks which ensure that you don't have to make calls to the live Gumroad API from non-prod environments. To use mock responses, set :gumroad_elixir :client to Gumroad.Client.Mock (more details on the Gumroad.Client docs ). Now when you perform an action that would create a request against the Gumroad API, you'll get a mocked response instead: iex&gt; Gumroad . get_resource_subscriptions ( &quot;abc&quot; ) { :ok , % Gumroad.ResourceSubscription { id : &quot;test-resource-subscription-id&quot; , post_url : &quot;http://example.org&quot; , resource_name : &quot;abc&quot; } } Incomplete implementation This package does not implement the entire Gumroad API. I extracted it out of a project ( Mailgrip ) where I only implemented support for the endpoints I needed. An overall framework has been created though, with the intention of making addition of new endpoints straightforward. If you'd like support for a new endpoint, I'd love for you to open a PR (my preference!) or otherwise open an issue and I can look into adding support. What API endpoints are implemented? The following table tracks all endpoints currently available on the Gumroad API and whether they've been implemented in this package. Gumroad API Implemented? GET /products ✅ GET /products/:product_id/subscribers ✅ PUT /resource_subscriptions ✅ GET /resource_subscriptions ✅ DELETE /resource_subscriptions/:resource_subscription_id ✅ GET /sales/:id ✅ GET /subscribers/:id ✅ GET /sales ✅ GET /products/:id ❌ DELETE /products/:id ❌ PUT /products/:id/enable ❌ PUT /products/:id/disable ❌ POST /products/:product_id/variant_categories ❌ GET /products/:product_id/variant_categories/:id ❌ PUT /products/:product_id/variant_categories/:id ❌ DELETE /products/:product_id/variant_categories/:id ❌ GET /products/:product_id/variant_categories ❌ POST /products/:product_id/variant_categories/:variant_category_id/variants ❌ GET /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ PUT /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ DELETE /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ GET /products/:product_id/variant_categories/:variant_category_id/variants ❌ GET /products/:product_id/offer_codes ❌ GET /products/:product_id/offer_codes/:id ❌ POST /products/:product_id/offer_codes ❌ PUT /products/:product_id/offer_codes/:id ❌ DELETE /products/:product_id/offer_codes/:id ❌ GET /products/:product_id/custom_fields ❌ POST /products/:product_id/custom_fields ❌ PUT /products/:product_id/custom_fields/:name ❌ DELETE /products/:product_id/custom_fields/:name ❌ GET /user ❌ PUT /sales/:id/mark_as_shipped ❌ PUT /sales/:id/refund ❌ POST /licenses/verify ❌ PUT /licenses/enable ❌ PUT /licenses/disable ❌ PUT /licenses/decrement_uses_count ❌ What else needs to be done? Besides supporting all API endpoints, there are a few other areas I'd like to tackle before calling this client &quot;production ready&quot;: Retry mechanism in case an API request fails. Telemetry. Consider moving off of HTTPoison dependency and onto native httpc.","ref":"Gumroad.html","title":"Gumroad","type":"module"},{"doc":"The Gumroad client to use. Setting the :gumroad_elixir :client config value will determine which client gets returned by this function. In production, this will be Gumroad.Client.Live , for testing this will likely be Gumroad.Client.Mock .","ref":"Gumroad.html#client/0","title":"Gumroad.client/0","type":"function"},{"doc":"Callback implementation for Gumroad.Client.create_resource_subscription/1 .","ref":"Gumroad.html#create_resource_subscription/1","title":"Gumroad.create_resource_subscription/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.delete_resource_subscription/1 .","ref":"Gumroad.html#delete_resource_subscription/1","title":"Gumroad.delete_resource_subscription/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_products/0 .","ref":"Gumroad.html#get_products/0","title":"Gumroad.get_products/0","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_resource_subscriptions/1 .","ref":"Gumroad.html#get_resource_subscriptions/1","title":"Gumroad.get_resource_subscriptions/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_sale/1 .","ref":"Gumroad.html#get_sale/1","title":"Gumroad.get_sale/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_sales/1 .","ref":"Gumroad.html#get_sales/1","title":"Gumroad.get_sales/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_subscriber/1 .","ref":"Gumroad.html#get_subscriber/1","title":"Gumroad.get_subscriber/1","type":"function"},{"doc":"Callback implementation for Gumroad.Client.get_subscribers/1 .","ref":"Gumroad.html#get_subscribers/1","title":"Gumroad.get_subscribers/1","type":"function"},{"doc":"Defines a behaviour of a client that can be used for performing actions against a Gumroad implementation. Two implementations are provided: Gumroad.Client.Live - Default client used in production. This one connects to the Gumroad API. Gumroad.Client.Mock - Client to be used in tests. This returns canned responses without making requests to the Gurmoad API. You can configure your application to use either of these implementation by setting the :gumroad_elixir , :client config property: # In test mode, you&#39;d probably want to use the Mock implementation # config/test.exs config :gumroad_elixir , :client , Gumroad.Client.Mock # In prod, you should use the Live implementation (which is the default) # config/prod.exs config :gumroad_elixir , :client , Gumroad.Client.Live","ref":"Gumroad.Client.html","title":"Gumroad.Client","type":"behaviour"},{"doc":"Subscribe to a resource. Valid resource names are: sale refund dispute dispute_won cancellation subscription_updated subscription_ended subscription_restarted API When using Gumroad.Client.Live , this will call the Gumroad API at PUT /resource_subscriptions .","ref":"Gumroad.Client.html#c:create_resource_subscription/1","title":"Gumroad.Client.create_resource_subscription/1","type":"callback"},{"doc":"Unsubscribe from a resource. API When using Gumroad.Client.Live , this will call the Gumroad API at DELETE /resource_subscriptions/:resource_subscription_id .","ref":"Gumroad.Client.html#c:delete_resource_subscription/1","title":"Gumroad.Client.delete_resource_subscription/1","type":"callback"},{"doc":"Retrieve all of the existing products. API When using Gumroad.Client.Live , this will call the Gumroad API at GET /products .","ref":"Gumroad.Client.html#c:get_products/0","title":"Gumroad.Client.get_products/0","type":"callback"},{"doc":"Retrieve all active subscriptions for the given resource name. Valid resource names are: sale refund dispute dispute_won cancellation subscription_updated subscription_ended subscription_restarted API When using Gumroad.Client.Live , this will call the Gumroad API at GET /resource_subscriptions .","ref":"Gumroad.Client.html#c:get_resource_subscriptions/1","title":"Gumroad.Client.get_resource_subscriptions/1","type":"callback"},{"doc":"Retrieve a sale by its ID. API When using Gumroad.Client.Live , this will call the Gumroad API at GET /sales/:id .","ref":"Gumroad.Client.html#c:get_sale/1","title":"Gumroad.Client.get_sale/1","type":"callback"},{"doc":"Retrieves all of the successful sales by the authenticated user. Parameters after (optional, date in form YYYY-MM-DD) - Only return sales after this date before (optional, date in form YYYY-MM-DD) - Only return sales before this date product_id (optional) - Filter sales by this product email (optional) - Filter sales by this email order_id (optional) - Filter sales by this Order ID page (number) - Return this page of results API When using Gumroad.Client.Live , this will call the Gumroad API at GET /sales .","ref":"Gumroad.Client.html#c:get_sales/1","title":"Gumroad.Client.get_sales/1","type":"callback"},{"doc":"Retrieve a subscriber by their ID. API When using Gumroad.Client.Live , this will call the Gumroad API at GET /subscribers/:id .","ref":"Gumroad.Client.html#c:get_subscriber/1","title":"Gumroad.Client.get_subscriber/1","type":"callback"},{"doc":"Retrieve the subscribers of the given product. API When using Gumroad.Client.Live , this will call the Gumroad API at GET /products/:product_id/subcribers .","ref":"Gumroad.Client.html#c:get_subscribers/1","title":"Gumroad.Client.get_subscribers/1","type":"callback"},{"doc":"","ref":"Gumroad.Client.html#t:get_sales_params/0","title":"Gumroad.Client.get_sales_params/0","type":"type"},{"doc":"A Gumroad product. See the Gumroad docs for more info.","ref":"Gumroad.Product.html","title":"Gumroad.Product","type":"module"},{"doc":"","ref":"Gumroad.Product.html#new/1","title":"Gumroad.Product.new/1","type":"function"},{"doc":"","ref":"Gumroad.Product.html#t:t/0","title":"Gumroad.Product.t/0","type":"type"},{"doc":"","ref":"Gumroad.Product.html#t:variant/0","title":"Gumroad.Product.variant/0","type":"type"},{"doc":"","ref":"Gumroad.Product.html#t:variant_option/0","title":"Gumroad.Product.variant_option/0","type":"type"},{"doc":"A Gumroad resource subscription. See the Gumroad docs for more info.","ref":"Gumroad.ResourceSubscription.html","title":"Gumroad.ResourceSubscription","type":"module"},{"doc":"","ref":"Gumroad.ResourceSubscription.html#new/1","title":"Gumroad.ResourceSubscription.new/1","type":"function"},{"doc":"","ref":"Gumroad.ResourceSubscription.html#t:create_params/0","title":"Gumroad.ResourceSubscription.create_params/0","type":"type"},{"doc":"","ref":"Gumroad.ResourceSubscription.html#t:t/0","title":"Gumroad.ResourceSubscription.t/0","type":"type"},{"doc":"A Gumroad sale. See the Gumroad docs for more info.","ref":"Gumroad.Sale.html","title":"Gumroad.Sale","type":"module"},{"doc":"","ref":"Gumroad.Sale.html#new/1","title":"Gumroad.Sale.new/1","type":"function"},{"doc":"","ref":"Gumroad.Sale.html#t:affiliate/0","title":"Gumroad.Sale.affiliate/0","type":"type"},{"doc":"","ref":"Gumroad.Sale.html#t:t/0","title":"Gumroad.Sale.t/0","type":"type"},{"doc":"A Gumroad subscriber. See the Gumroad docs for more info.","ref":"Gumroad.Subscriber.html","title":"Gumroad.Subscriber","type":"module"},{"doc":"","ref":"Gumroad.Subscriber.html#new/1","title":"Gumroad.Subscriber.new/1","type":"function"},{"doc":"","ref":"Gumroad.Subscriber.html#t:t/0","title":"Gumroad.Subscriber.t/0","type":"type"},{"doc":"Utilities to aid in writing tests that mock Gumroad instead of calling its live API. See Gumroad.Client for more info about the Mock client.","ref":"Gumroad.Testing.html","title":"Gumroad.Testing","type":"module"},{"doc":"Provides fixtures that can be used with a mock Gumroad API client implementation, to simulate a response from Gumroad. See Gumroad.Client for more info about the Mock client.","ref":"Gumroad.Testing.Fixtures.html","title":"Gumroad.Testing.Fixtures","type":"module"},{"doc":"","ref":"Gumroad.Testing.Fixtures.html#product/0","title":"Gumroad.Testing.Fixtures.product/0","type":"function"},{"doc":"","ref":"Gumroad.Testing.Fixtures.html#resource_subscription/1","title":"Gumroad.Testing.Fixtures.resource_subscription/1","type":"function"},{"doc":"","ref":"Gumroad.Testing.Fixtures.html#sale/1","title":"Gumroad.Testing.Fixtures.sale/1","type":"function"},{"doc":"","ref":"Gumroad.Testing.Fixtures.html#subscriber/1","title":"Gumroad.Testing.Fixtures.subscriber/1","type":"function"},{"doc":"An error encountered while trying to query the Gumroad API.","ref":"Gumroad.Error.html","title":"Gumroad.Error","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Gumroad.Error.html#message/1","title":"Gumroad.Error.message/1","type":"function"},{"doc":"An error encountered while trying to query the Gumroad API. from_gumroad - set to true if Gumroad was reached but returned an error while processing the request. Set to false if Gumroad could not be reached at all. reason - set to the error message returned from Gumroad when from_gumroad is true . Otherwise is an atom pointing to the underlying error, i.e. :timeout .","ref":"Gumroad.Error.html#t:t/0","title":"Gumroad.Error.t/0","type":"type"},{"doc":"An unofficial Gumroad API client for Elixir applications. ⚠️ Pay heed! This package does not yet implement the complete Gumroad API. See the &quot;Incomplete implementation&quot; section below for more details.","ref":"readme.html","title":"gumroad_elixir","type":"extras"},{"doc":"Full documentation available on HexDocs .","ref":"readme.html#documentation","title":"gumroad_elixir - Documentation","type":"extras"},{"doc":"iex&gt; { :ok , products } = Gumroad . get_products ( ) iex&gt; products [ % Gumroad.Product { id : &quot;...&quot; , name : &quot;...&quot; } , % Gumroad.Product { id : &quot;...&quot; , name : &quot;...&quot; } ] iex&gt; { :ok , subscribers } = Gumroad . get_subscribers ( List . first ( products ) . id ) iex&gt; subscribers [ % Gumroad.Subscriber { id : &quot;...&quot; , status : &quot;alive&quot; } ]","ref":"readme.html#usage","title":"gumroad_elixir - Usage","type":"extras"},{"doc":"Add gumroad_elixir to your list of dependencies in mix.exs : def deps do [ { :gumroad_elixir , &quot;~&gt; 0.1.0&quot; } ] end Then, configure your Gumroad access token : # config.exs config :gumroad_elixir , :access_token , &quot;your-gumroad-access-token&quot;","ref":"readme.html#installation","title":"gumroad_elixir - Installation","type":"extras"},{"doc":"Configuration properties on the :gumroad_elixir application are: :access_token (required) - The access token used to authenticate to the Gumroad API. (For details on how to create an access token, see Gumroad docs ). :client (defaults to Gumroad.Client.Live ) - The client implementation to use when handling API operations. Used for swithcing between a mock client and one that makes requests against the live Gumroad API. More details on the Gumroad.Client docs .","ref":"readme.html#configuration","title":"gumroad_elixir - Configuration","type":"extras"},{"doc":"Error messages sent by Gumroad's API in response to failed requests are propagated as-is to your application, with the from_gumroad property set to true : iex&gt; Gumroad . get_sale ( &quot;not-a-real-sale&quot; ) { :error , % Gumroad.Error { from_gumroad : true , reason : &quot;The sale was not found.&quot; } } Errors caused by other reasons (like network timeouts) have the from_gumroad property set to false : # Disconnect wi-fi, and... iex&gt; Gumroad.Client . get_sale ( &quot;not-a-real-sale&quot; ) { :error , % Gumroad.Error { from_gumroad : false , reason : :timeout } }","ref":"readme.html#error-handling","title":"gumroad_elixir - Error handling","type":"extras"},{"doc":"An access token is included as a parameter on each request made to the Gumroad API. To create an access token, see Gumroad's docs .","ref":"readme.html#authentication","title":"gumroad_elixir - Authentication","type":"extras"},{"doc":"Gumroad doesn't currently offer a native solution for local development or testing. To make up for this, this package includes local dev and testing mocks which ensure that you don't have to make calls to the live Gumroad API from non-prod environments. To use mock responses, set :gumroad_elixir :client to Gumroad.Client.Mock (more details on the Gumroad.Client docs ). Now when you perform an action that would create a request against the Gumroad API, you'll get a mocked response instead: iex&gt; Gumroad . get_resource_subscriptions ( &quot;abc&quot; ) { :ok , % Gumroad.ResourceSubscription { id : &quot;test-resource-subscription-id&quot; , post_url : &quot;http://example.org&quot; , resource_name : &quot;abc&quot; } }","ref":"readme.html#testing","title":"gumroad_elixir - Testing","type":"extras"},{"doc":"This package does not implement the entire Gumroad API. I extracted it out of a project ( Mailgrip ) where I only implemented support for the endpoints I needed. An overall framework has been created though, with the intention of making addition of new endpoints straightforward. If you'd like support for a new endpoint, I'd love for you to open a PR (my preference!) or otherwise open an issue and I can look into adding support. What API endpoints are implemented? The following table tracks all endpoints currently available on the Gumroad API and whether they've been implemented in this package. Gumroad API Implemented? GET /products ✅ GET /products/:product_id/subscribers ✅ PUT /resource_subscriptions ✅ GET /resource_subscriptions ✅ DELETE /resource_subscriptions/:resource_subscription_id ✅ GET /sales/:id ✅ GET /subscribers/:id ✅ GET /sales ✅ GET /products/:id ❌ DELETE /products/:id ❌ PUT /products/:id/enable ❌ PUT /products/:id/disable ❌ POST /products/:product_id/variant_categories ❌ GET /products/:product_id/variant_categories/:id ❌ PUT /products/:product_id/variant_categories/:id ❌ DELETE /products/:product_id/variant_categories/:id ❌ GET /products/:product_id/variant_categories ❌ POST /products/:product_id/variant_categories/:variant_category_id/variants ❌ GET /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ PUT /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ DELETE /products/:product_id/variant_categories/:variant_category_id/variants/:id ❌ GET /products/:product_id/variant_categories/:variant_category_id/variants ❌ GET /products/:product_id/offer_codes ❌ GET /products/:product_id/offer_codes/:id ❌ POST /products/:product_id/offer_codes ❌ PUT /products/:product_id/offer_codes/:id ❌ DELETE /products/:product_id/offer_codes/:id ❌ GET /products/:product_id/custom_fields ❌ POST /products/:product_id/custom_fields ❌ PUT /products/:product_id/custom_fields/:name ❌ DELETE /products/:product_id/custom_fields/:name ❌ GET /user ❌ PUT /sales/:id/mark_as_shipped ❌ PUT /sales/:id/refund ❌ POST /licenses/verify ❌ PUT /licenses/enable ❌ PUT /licenses/disable ❌ PUT /licenses/decrement_uses_count ❌ What else needs to be done? Besides supporting all API endpoints, there are a few other areas I'd like to tackle before calling this client &quot;production ready&quot;: Retry mechanism in case an API request fails. Telemetry. Consider moving off of HTTPoison dependency and onto native httpc.","ref":"readme.html#incomplete-implementation","title":"gumroad_elixir - Incomplete implementation","type":"extras"}]